<?
$datetime1=new DateTime($fec11);
$datetime2=new DateTime($fec22);
$interval=$datetime2->diff($datetime1);
$months=$interval->format("%m")+($interval->format("%y")*12);
$days=$interval->format("%d");
$months=$months<4&&$days>0?($months+1):$months;


//********** CONSULTA PRESTACION ********************/
$selectPrestacion = "SELECT IFNULL(monto_prestacion,0) AS mtoPrestacion, IFNULL(monto_dias,0) as mtoDias,  IFNULL(anticipo,0) as mtoAnticipo, fecha_desde, ano, mes, dias_base, dias_adicionales FROM prestaciones WHERE cedula = '".$cedula."' AND id ='".$_SESSION['id_validar']."' AND fecha_desde = '2021-12-31'";
$consultaPrestacion = mysqli_query($enlace,$selectPrestacion) or die ($selectPrestacion.mysqli_error($enlace));
$inicioPrestacion=mysqli_fetch_array($consultaPrestacion);
$mtoPrestacion = 0;
$mtoDias = 0;
$mtoAnticipo = 0;
$acumulado = 0;
$acumulato_total = 0 ;

if (mysqli_num_rows($consultaPrestacion)!=0){
	$mtoPrestacion = $inicioPrestacion['mtoPrestacion'];
	$mtoDias = $inicioPrestacion['mtoDias'];
	$mtoAnticipo = $inicioPrestacion['mtoAnticipo'];
	$acumulado = $mtoPrestacion + $mtoDias - $mtoAnticipo;
	$acumulato_total = $mtoPrestacion + $mtoDias - $mtoAnticipo;
	$fec11 ='2021-12-28';//*.substr($fec11,8,2);*/
	$anos = $inicioPrestacion['ano'];
	$anosx = $inicioPrestacion['mes'];
	$cuantosmeses = number_format($anosx,0);
	$tdias = $inicioPrestacion['dias_base'] + $inicioPrestacion['dias_adicionales'];
	
	if ($_POST['tipo_salida']==1) {
		$color=!$color;
		$pdf->cell($ancho,5,$inicioPrestacion['fecha_desde'],0,0,'C',$color);
		$pdf->cell(10,5,number_format($anos,0),0,0,'R',$color);
		$pdf->cell(10,5,number_format($anosx,0),0,0,'R',$color);
		$pdf->cell(10,5,number_format($inicioPrestacion['dias_base']),0,0,'R',$color);
		$pdf->cell(10,5,number_format($inicioPrestacion['dias_adicionales']),0,0,'R',$color);
		$pdf->cell($ancho,5,number_format(0,2),0,0,'R',$color);
		$pdf->cell(15,5,number_format(0,2),0,0,'R',$color);
		$pdf->cell(15,5,number_format(0,2),0,0,'R',$color);
		$pdf->cell($ancho,5,number_format(0,2),0,0,'R',$color);
		$pdf->cell($ancho,5,number_format(0,2),0,0,'R',$color);
		$pdf->cell($ancho,5,number_format($acumulado,2),0,0,'R',$color);
		$pdf->cell($ancho,5,number_format($acumulato_total,2),0,0,'R',$color);
		$pdf->cell($ancho,5,number_format($mtoAnticipo,2),0,0,'R',$color);
		$pdf->cell($ancho,5,number_format(0,2),0,0,'R',$color);
		$pdf->cell($ancho,5,number_format(0,2),0,0,'R',$color);
		$pdf->cell($ancho,5,number_format(0,2),0,0,'R',$color);
		$pdf->cell($ancho,5,number_format(0,2),0,1,'R',$color);

	}
	if ($_POST['tipo_salida']==2) {
			echo "<tr>";
			echo "<td>".substr($inicioPrestacion['fecha_desde'],0,7)."</td>";
			echo "<td bgcolor='#EEEFF3' align=right>".number_format($anos,0)."</td>";
			echo "<td bgcolor='#EEEFF3' align=right>".number_format($anosx,0)."</td>";
			echo "<td bgcolor='#EEEFF3' align=right><b><font color=#36C1E2>".number_format($inicioPrestacion['dias_base'],0)."</b></font></td>";
			echo "<td bgcolor='#EEEFF3' align=right><b><font color=#36C1E2>".number_format($inicioPrestacion['dias_adicionales'],0)."</b></font></td>";
			echo "<td bgcolor='#FCFCFC' align=right><b><font color=#84BE45>".number_format(0,2)."</b></font></td>";
			echo "<td bgcolor='#EEEFF3' align=right>".number_format(0,2)."</td>";
			echo "<td bgcolor='#EEEFF3' align=right>".number_format(0,2)."</td>";
			echo "<td bgcolor='#EEEFF3' align=right>".number_format(0,2)."</td>";
			echo "<td align=right><b>".number_format($acumulado,2)."</b></td>";
			echo "<td align=right><b>".number_format($acumulato_total,2)."</b></td>";
			echo "<td align=right><b><font color=#E47470>".number_format($mtoAnticipo,2)."</font></b></td>";
			echo "<td align=right><b>".number_format($acumulato_total,2)."</b></td>";
			echo "<td bgcolor='#FCFCFC' align=right>".number_format(0,2)."</td>";
			//echo "<td bgcolor='#FCFCFC' align=right>".number_format($prestaciones*$interes/100/12,2)."</td>"; *********** Geisy 9/05/2022
			echo "<td bgcolor='#FCFCFC' align=right>".number_format(0,2)."</td>";

			echo "<td bgcolor='#FCFCFC' align=right><b><font color=#36C1E2>".number_format(0,2)."</b></font></td>";
			echo "<td bgcolor='#FCFCFC' align=right>".number_format(0,2)."</td>";
			echo "<td bgcolor='#FCFCFC' align=right>".number_format(0,2)."</td>";
			echo "</tr>";
			}
			
}

$selectPrestacion="delete from prestaciones where id='".$_SESSION['id_validar']."' and cedula = '".$cedula."' and fecha_desde > '2021-12-31'";
$eliminaPrestacion = mysqli_query($enlace,$selectPrestacion) or die ($selectPrestacion.':>'.mysqli_error($enlace));

while ($fec11<$fec22) {
	

			$cuantosmeses++;
			//====================== calcular años
			$anosx++;
			if ($anosx>12) {
				$anos++;
				$anosx=1;
			}

			//====================== mover fechas
			// $a=substr($fec11x,0,4);
			// $d=substr($fec11x,8,2);
			// $m=substr($fec11x,5,2)+1;
			// if ($m>12) {
			// 	$m='01';
			// 	$a=$a+1;
			// } else $m=(strlen($m)==1?('0'.$m):$m);
			// $fec11x=$a."-".$m."-".$d;

			//====================== ver cual periodo es
		
			$nuevafecha = strtotime ( '+1 month' , strtotime ( $fec11 ) ) ;
			
            $fec11 = date ( 'Y-m-d' , $nuevafecha );
			//===================== buscar dias de utilidades en historico
			//$consulta=mysqli_query($enlace,"select dvac,duti from historico_parametro where id='".$_SESSION['id_validar']."' and anio='".$a."'") or die (mysqli_error($enlace));
			$consulta=mysqli_query($enlace,"SELECT duti, dbon FROM empresa WHERE id='".$_SESSION['id_validar']."'") or die (mysqli_error($enlace));
			if (mysqli_num_rows($consulta)!=0) {
				$row=mysqli_fetch_array($consulta);
				$dvacx=$row['dbon'];
				$dutix=$row['duti'];

			} else {
				$dvacx=$dvac;
				$dutix=$duti;

			}

			//====================== salto de tres en tres desde 05-2012
			// if ($tri==1) {
			// 	$salto++; $dias=0;
			// 	if ($salto==3) {
			// 		$salto=0;
			// 		$dias=15;
			// 	}
			// } else {
			// 	if ($fec11<='2012-04-01') {
			// 		if ($fec11=='2012-04-01') $tri=1;
			// 		$dias=5;
			// 	} else {
			// 		$tri=1;
			// 		$salto++; $dias=0;
			// 		if ($salto==3) {
			// 			$salto=0;
			// 			$dias=15;
			// 		}
			// 	}
			// }

			//********************* GEISY 10/05/2022  ******************************** */
			if($cuantosmeses%3!=0){
				$dias=0;
			} else {
				$dias=15;
			}

			//====================== agregado para revalidar dias

			//Agregado por cambios en dia de ingreso
            $fecAux=$fec11;
            $mostrar=true;
			if($fec11>=$fec22){
			   $fec11=$fec22;
			   if($egresado){
			       	/*if($dias==0){
			             if($cuantosmeses>3){
					         $dias=15;
				             $ultdias=true;
					    }
			        }*/
					 if($cuantosmeses>3){
					     $ultdias=true;
						 if($dias==0){
						    $dias=15;
						 }
					 }
			   }else{
			      if($cuantosmeses%3!=0){
				     $dias=0;
				  }
			   }
			}

			if($fecAux>$fec22&&!$egresado){
				$mostrar=false;
			}
			if($egresado){
			   if($months<4){
				     if($months==$cuantosmeses){
				         $dias=5*$months;
				     }else{
					     $dias=0;
					}
                 $ultdias=false;
			    }
			}
         if($mostrar){
			//====================== calcular inicio
			$inicio++;
			if ($inicio<=3 && $fec11<'2012-04-01') $dias=0;

			//============ datos de adelantos

			$consulta=mysqli_query($enlace,"select IFNULL(sum(monto),0) as total from prestacion_adelanto where id='".$_SESSION['id_validar']."' and substring(fecha,1,7)='".substr($fecAux,0,7)."' and cedula='".$cedula."'") or die (mysqli_error($enlace));
			$row=mysqli_fetch_array($consulta);
			$adelanto=$row['total'];


			$consulta=mysqli_query($enlace,"select IFNULL(sum(monto),0) as total from prestacion_interes where id='".$_SESSION['id_validar']."' and substring(fecha,1,7)='".substr($fecAux,0,7)."' and cedula='".$cedula."'") or die (mysqli_error($enlace));
			$row=mysqli_fetch_array($consulta);
			$adeinteres=$row['total'];

			//============ datos de sueldo
			$fec11ant = strtotime ( '-1 month' , strtotime ( $fec11 ) ) ;
				$fec11ant = date ( 'Y-m' , 	$fec11ant );

			$consulta=mysqli_query($enlace,"select SUM(sueldo) AS sueldo from personal_sueldo where id='".$_SESSION['id_validar']."' and substring(fec,1,7)='".substr($fec11ant,0,7)."' and codigo='".$cedula."' ") or die (mysqli_error($enlace));



			//echo "select sueldo from personal_sueldo where id='".$_SESSION['id_validar']."' and substring(fec,1,7)='".$fec11."' and codigo='".$cedula."'<br>";
			$row=mysqli_fetch_array($consulta);
			if (mysqli_num_rows($consulta)!=0) {

				$sueldo=$row['sueldo'];
					if ($con01!='') {
						$consultax="select monto from constante_individual where id='".$_SESSION['id_validar']."' and codigo='".$con01."' and cedula='".$cedula."' and nomina='".$tiponomina."'";
						$resultadox = mysqli_query($enlace,$consultax) or die('verificaci&oacute; del c&oacute;digo fall&oacute;: ' . mysqli_error($enlace));
						if (mysqli_num_rows($resultadox)!=0) {
							$rowx=mysqli_fetch_array($resultadox);
							if ($tipoclase==1) $sueldo=$sueldo + $rowx['monto']/7*30;
							//else if ($tipoclase==2) $sueldo=$sueldo + $rowx['monto']*2;
								else if ($tipoclase==2) $sueldo=$sueldo *2; //porque debe funcionar con nom,inas cerradas unciamente -- Miguelangel 26/04/22
								else $sueldo=$sueldo + $rowx['monto'];
						}
					}
					if ($con02!='') {
						$consultax="select monto from constante_individual where id='".$_SESSION['id_validar']."' and codigo='".$con02."' and cedula='".$cedula."' and nomina='".$tiponomina."'";
						$resultadox = mysqli_query($enlace,$consultax) or die('verificaci&oacute; del c&oacute;digo fall&oacute;: ' . mysqli_error($enlace));
						if (mysqli_num_rows($resultadox)!=0) {
							$rowx=mysqli_fetch_array($resultadox);
							if ($tipoclase==1) $sueldo=$sueldo + $rowx['monto']/7*30;
							else if ($tipoclase==2) $sueldo=$sueldo + $rowx['monto']*2;
								else $sueldo=$sueldo + $rowx['monto'];
						}
					}
					/*if ($con03!='') {

						$consultax="select sum(monto) as total from historico where id='".$_SESSION['id_validar']."' and substring(desperiodo,1,7)='".$fec11."' and concepto='".$con03."' and cedula='".$cedula."' and nomina='".$tiponomina."'";
						//echo $consultax."<br>";
						$resultadox = mysqli_query($enlace,$consultax) or die('verificaci&oacute; del c&oacute;digo fall&oacute;: ' . mysqli_error($enlace));
						$rowx=mysqli_fetch_array($resultadox);
						$sueldo= $rowx['total'] + $sueldo;
					}*/
			} else {
					//====================== buscar monto conceptos acmulado
					 //echo $con04."<br>";
					if ($con04!='') {

						$consultax="select sum(monto) as total from historico where id='".$_SESSION['id_validar']."' and substring(desperiodo,1,7)='".substr($fec11,0,7)."' and substring(concepto,1,".strlen($con04).")='".$con04."' and cedula='".$cedula."' and nomina='".$tiponomina."'";
						$resultadox = mysqli_query($enlace,$consultax) or die('verificaci&oacute; del c&oacute;digo fall&oacute;: ' . mysqli_error($enlace));
						$rowx=mysqli_fetch_array($resultadox);
						if ($rowx['total']>0) $sueldo= ($rowx['total']<$sueldominimo ? $sueldominimo : $rowx['total']);
						else $sueldo= $sueldominimo;
						$consulta5=mysqli_query($enlace,"select codigo from personal_sueldo where id='".$_SESSION['id_validar']."' and substring(fec,1,7)='".substr($fec11,0,7)."' and codigo='".$cedula."'") or die (mysqli_error($enlace));
						if (mysqli_num_rows($consulta5)==0)
							$consulta5=mysqli_query($enlace,"insert into personal_sueldo (id,fec,codigo,sueldo) values ('".$_SESSION['id_validar']."','".(substr($fec11,0,7).'-01')."','".$cedula."','".$sueldo."')") or die (mysqli_error($enlace));
					}
			}
			//$alivac= ($dvacx/12*$sueldo/30/30);
			$alivac = ($dvacx/360*$sueldo/30);
			//$aliuti= ($dutix/12*$sueldo/30/30);
			$aliuti = ($dutix/360*$sueldo/30);
			$integral = ($sueldo/30) + $alivac + $aliuti;

			//============ datos de interes
			if ($icon!=2) {
				$consulta=mysqli_query($enlace,"select mon as total from tab_interes where substring(fec,1,7)='".substr($fec11,0,7)."'");
				$row=mysqli_fetch_array($consulta);
			}
			if ($row['total']==0) ///no hay tasa ese mes
				$tcolor='red';
			else $tcolor='black'; /// si hay tasa ese mes

			$interes=($row['total']==0?$interes:$row['total']);

			//============ calculo
										//============ dia adicional
			if ($anosx==12 && $anos>=1) {
				$diaa = $anos*2;
				if ($diaa>30) {
					$diaa=30;
				}
				
				$prestacion_mes = $integral*$diaa ;
				$interes_mes = $prestacion_mes * $interes / 100 / 12 ;
				//$acumulado += $prestacion_mes;
				//$interesganados += ($interes_mes) ;

				
		} else $diaa=0;

			$prestacion_mes = $integral*($dias + $diaa ) ;
				//$interes_mes = $prestacion_mes * $interes / 100 / 12 ;
			$acumulado += $prestacion_mes - $adelanto;
			$acumulato_total  += $prestacion_mes ;
			$fechaPrestacion = substr($fec11,0,7).'-28';
			$intereses = ($acumulado*$interes/100/12)   ;
			$intereses = ($intereses > 0 ? $intereses : 0 ) ;
			



			//$interesganados += ($intereses)-$adeinteres;
			$interesganados += ($intereses) ;
			$acumintpag+=$adeinteres;
			$saldo_intereses_neto = $interesganados - $acumintpag ;
			
			if ($_POST['tipo_salida']==1) {
				$color=!$color;
				$pdf->cell($ancho,5,substr($fec11,0,7),0,0,'C',$color);
				$pdf->cell(10,5,number_format($anos,0),0,0,'R',$color);
				$pdf->cell(10,5,number_format($anosx,0),0,0,'R',$color);
				$pdf->cell(10,5,number_format($dias,0),0,0,'R',$color);
				$pdf->cell($ancho,5,number_format($sueldo,2),0,0,'R',$color);
				$pdf->cell(15,5,number_format($alivac,2),0,0,'R',$color);
				$pdf->cell(15,5,number_format($aliuti,2),0,0,'R',$color);
				$pdf->cell($ancho,5,number_format($integral,2),0,0,'R',$color);
				$pdf->cell($ancho,5,number_format($integral*$dias,2),0,0,'R',$color);
				$pdf->cell($ancho,5,number_format($acumulado,2),0,0,'R',$color);
				$pdf->cell($ancho,5,number_format($adelanto,2),0,0,'R',$color);
				$pdf->cell($ancho,5,number_format($interes,2),0,0,'R',$color);
				$pdf->cell($ancho,5,number_format($intereses,2),0,0,'R',$color);
				$pdf->cell($ancho,5,number_format($interesganados,2),0,0,'R',$color);
				$pdf->cell($ancho,5,number_format($adeinteres,2),0,1,'R',$color);

			}
			if ($_POST['tipo_salida']==2) {
				echo "<tr>";
				echo "<td>".substr($fec11,0,7)."</td>";
				echo "<td bgcolor='#EEEFF3' align=right>".number_format($anos,0)."</td>";
				echo "<td bgcolor='#EEEFF3' align=right>".number_format($anosx,0)."</td>";
				echo "<td bgcolor='#EEEFF3' align=right><b><font color=#36C1E2>".number_format($dias,0)."</b></font></td>";
				echo "<td bgcolor='#EEEFF3' align=right><b><font color=#36C1E2>".number_format($diaa,0)."</b></font></td>";

				echo "<td bgcolor='#FCFCFC' align=right><b><font color=#84BE45>".number_format($sueldo,2)."</b></font></td>";
				echo "<td bgcolor='#EEEFF3' align=right>".number_format($alivac,2)."</td>";
				echo "<td bgcolor='#EEEFF3' align=right>".number_format($aliuti,2)."</td>";
				echo "<td bgcolor='#EEEFF3' align=right>".number_format($integral,2)."</td>";
				echo "<td bgcolor='#EEEFF3' align=right>".number_format($prestacion_mes,2)."</td>";
				echo "<td bgcolor='#EEEFF3' align=right>".number_format($acumulato_total,2)."</td>";
				echo "<td align=right><b><font color=#E47470>".number_format($adelanto,2)."</font></b></td>";
				echo "<td align=right><b>".number_format($acumulado,2)."</b></td>";
				echo "<td bgcolor='#FCFCFC' align=right>".number_format($interes,2)."</font></td>";
				//echo "<td bgcolor='#FCFCFC' align=right>".number_format($prestaciones*$interes/100/12,2)."</td>"; *********** Geisy 9/05/2022
				echo "<td bgcolor='#FCFCFC' align=right>".number_format($intereses,2)."</td>";

				echo "<td bgcolor='#FCFCFC' align=right><b>".number_format($interesganados,2)."</b></font></td>";
				echo "<td bgcolor='#FCFCFC' align=right>".number_format($adeinteres,2)."</td>";
				echo "<td bgcolor='#FCFCFC' align=right>".number_format($saldo_intereses_neto,2)."</td>";
				echo "</tr>";
				
				

			}
			
			//if ($prestaciones*$interes/100/12>0) {  *********** Geisy 9/05/2022
				//$interesganados += ($prestaciones*$interes/100/12)-$adeinteres;   *********** Geisy 9/05/2022
				
			//}   *********** Geisy 9/05/2022


		///////////Estos son los valores que se vana insertar en la tabla [prestacion]
		if ($fechaPrestacion > '2021-12-31'){
			$interes = $interes ? $interes : 0;
			$intereses = $acumulado*$interes/100/12 ;
			$intereses = ($intereses > 0 ? $intereses : 0 ) ;
			$valorSueldo = $sueldo ? $sueldo : 0;
			$crearRegistro = "INSERT INTO `prestaciones` (
			`ano`, 
			`mes`, 
			`cedula`, 
			`nomina`, 
			`id`, 
			`sueldo`, 
			`sueldo_integral`, 
			`dias_base`, 
			`monto_prestacion`, 
			`dias_adicionales`, 
			`monto_dias`, 
			`tasa_interes`, 
			`monto_interes`, 
			`anticipo`, 
			`anticipo_interes`, 
			`fecha_desde`)
			VALUES (
			'".$anos."',
			'".$anosx."',
			'".$cedula."',
			'".$tiponomina."',
			'".$_SESSION['id_validar']."',
			$valorSueldo,
			$integral,
			$dias,
			$integral*$dias,
			$diaa, 
			$integral*$diaa,
			$interes ,
			$intereses ,
			$adelanto, 
			$adeinteres,
			'".$fechaPrestacion."')";
			$qpersonal = mysqli_query($enlace,$crearRegistro) or die ($crearRegistro.mysqli_error($enlace));
			//echo "insert: ".$qpersonal;

		}

		
		$acumanticp+=$adelanto;
		$tdias += $dias+$diaa;
		$prestaciones += ($integral*$dias)+($integral*$diaa)-$adelanto;
    }
}
?>
